<?php

namespace App\domain\amadeus\v2;

use App\domain\amadeus\AddPNRMultiElementAction;
use App\domain\amadeus\SelFromRecommendationAction;
use Exception;

class StartPNRAction
{
    protected SelFromRecommendationAction $selFromRecommendationAction;
    protected AddPNRMultiElementAction $addPNRMultiElementAction;

    protected array $passenger;
    protected array $searchCriteriaFlight;
    protected array $segments;
    protected array $recommendation;
    protected array $travelers;

    public function __construct()
    {
        $this->selFromRecommendationAction = new SelFromRecommendationAction;
        $this->addPNRMultiElementAction = new AddPNRMultiElementAction;
    }
    public function execute(array $searchCriteria, array $offerDetails, array $travelers): array
    {
        $this->passenger = $searchCriteria['passenger'];
        $this->searchCriteriaFlight = $searchCriteria['searchCriteriaFlight'];
        $this->segments = $offerDetails['segments'];
        $this->recommendation = $offerDetails['recommendation'];
        $this->travelers = $travelers;

        $selFromRecommendationResponse = $this->selFromRecommendation();
        $addPNRMultiElementResponse = $this->addPNRMultiElement();

        return $addPNRMultiElementResponse;
    }

    protected function selFromRecommendation(): array
    {
        return $this->selFromRecommendationAction->execute(
            passengerCriteria: $this->passenger,
            searchCriteria: $this->searchCriteriaFlight,
            selectedSegments: $this->segments,
            recommendation: $this->recommendation
        );
    }

    protected function addPNRMultiElement(): array
    {
        return $this->addPNRMultiElementAction->execute(
            $this->travelers,
            session("amadeus-session-id"),
            session("amadeus-security-token")
        );
    }
}
