<?php

namespace App\domain\amadeus\v2;

use App\domain\amadeus\PaymentFlowAction;
use App\Models\AmaSession;
use Exception;

class StartPaymentFlowAction
{
    protected PaymentFlowAction $paymentFlowAction;

    public function __construct()
    {
        $this->paymentFlowAction = new PaymentFlowAction;
    }

    public function execute(
        string $reservationId,
        string $payType,
        string $otherCompany,
        array  $passengerCriteria,
    ) {

        $session = AmaSession::query()->where('reservationIdentifier', $reservationId)->first();

        return $this->paymentFlowAction->execute(
            $session["amadeusSessionId"],
            $session["amadeusSecurityToken"],
            $payType,
            $otherCompany,
            $passengerCriteria,
            $reservationId
        );
    }
}
